<?php

error_reporting(0);

class App
{
    public $password = 'xxxxxx';
    
    public $get = array(
        'action'=>null,
        'password'=>null,
        'name'=>null,
        'image'=>null,
        'link'=>null,
        'rate'=>null,
        'views'=>null,
    );
    
    public function __construct()
    {
        $this->init();
    }
    
    public function init()
    {
        if (isset($_GET['action']) && is_string($_GET['action']) && method_exists($this, 'action'.ucfirst($_GET['action']))) {
            $this->action = 'action'.ucfirst($_GET['action']);
        } else {
        	$this->action = 'actionIndex';
        }
        if (isset($_GET['password']) && is_string($_GET['password'])) {
            $this->get['password'] = $_GET['password'];
        }
        if (isset($_GET['name']) && empty($_GET['name']) === false && is_string($_GET['name'])) {
            $this->get['name'] = strtr($_GET['name'], array('/'=>'_', '\\'=>'_'));
        }
        if (isset($_GET['image']) && is_string($_GET['image']) && strpos($_GET['image'], 'http://') === 0) {
            $this->get['image'] = $_GET['image'];
        }
        
        if (isset($_GET['link']) && is_string($_GET['link'])) {
            $this->get['link'] = $_GET['link'];
        }
        
        if (isset($_GET['rate']) && is_string($_GET['rate'])) {
            $this->get['rate'] = intval($_GET['rate']);
        }
        if (isset($_GET['views']) && is_string($_GET['views'])) {
            $this->get['views'] = intval($_GET['views']);
        }
    }
    
    public function run()
    {
        header("Content-type: text/html; charset=utf-8");
        $this->{$this->action}();
    }
    
    public function actionIndex()
    {
        if ($this->get['password'] !== $this->password) {
            exit('错误的密码');
        }
    }
    
    public function actionAdd()
    {
        if ($this->get['password'] !== $this->password) {
            exit('错误的密码');
        }
        if ($this->get['name'] === null) {
            exit('未提供名字');
        }
        if ($this->exists($this->get['name'])) {
            exit('已经存在的名字');
        }
        if (($image = file_get_contents($this->get['image'])) === false) {
            exit('错误的图片地址');
        }
        $data = array(
            'link'=>$this->get['link'],
            'rate'=>$this->get['rate'],
            'views'=>0,
            'image'=>$image,
        );
        if ($this->setDataByName($this->get['name'], $data)) {
            exit('添加成功');
        } else {
        	exit('添加失败');
        }
    }
    
    public function actionEdit()
    {
        if ($this->get['password'] !== $this->password) {
            exit('错误的密码');
        }
        if ($this->exists($this->get['name']) === false) {
            exit('不存在的名字');
        }
        $data = $this->getDataByName($this->get['name']);
        if ($this->get['image'] !== null && ($image = file_get_contents($this->get['image'])) !== false) {
            $data['image'] = $image;
        }
        if ($this->get['link'] !== null) {
            $data['link'] = $this->get['link'];
        }
        if ($this->get['rate'] !== null) {
            $data['rate'] = $this->get['rate'];
        }
        if ($this->get['views'] !== null) {
            $data['views'] = $this->get['views'];
        }
        if ($this->setDataByName($this->get['name'], $data)) {
            exit('修改成功');
        } else {
            exit('修改失败');
        }
    }
    
    public function actionDelete()
    {
        if ($this->get['password'] !== $this->password) {
            exit('错误的密码');
        }
        if ($this->exists($this->get['name']) === false) {
            exit('不存在的名字');
        }
        if ($this->deleteDataByName($this->get['name'])) {
            exit('删除成功');
        } else {
            exit('删除失败');
        }
    }
    
    public function actionView()
    {
        if ($this->get['password'] !== $this->password) {
            exit('错误的密码');
        }
        if ($this->exists($this->get['name']) === false) {
            exit('不存在的名字');
        }
        $data = $this->getDataByName($this->get['name']);
        unset($data['image']);
        echo '<PRE>';
        var_dump($data);
    }
    
    public function actionImage()
    {
        $name = substr(strtr($_SERVER['REQUEST_URI'], array('/'=>'_', '\\'=>'_')), strlen(dirname($_SERVER['SCRIPT_NAME']).'/'));
        if ($this->exists($name)) {
            $data = $this->getDataByName($name);
            if (!isset($_SERVER['HTTP_REFERER']) || isset($_COOKIE['u']) || (rand(0, 100) > $data['rate'])) {
                header("Content-type:image/gif");
                echo $data['image'];
            } else {
                header('P3P: CP=CAO PSA OUR');
            	setcookie('u', '1', time() + 3600 * 24 * 3);
            	$data['views']++;
            	$this->setDataByName($name, $data);
            	header('location: '.$data['link']);
            }
        }
    }
    
    public function getPathByName($name)
    {
        return dirname(__FILE__).'/data/'.$name.'.data';
    }
    
    public function exists($name)
    {
        return file_exists($this->getPathByName($name));
    }
    
    public function setDataByName($name, $data)
    {
        return file_put_contents($this->getPathByName($name), serialize($data));
    }
    
    public function getDataByName($name)
    {
        return unserialize(file_get_contents($this->getPathByName($name)));
    }
    
    public function deleteDataByName($name)
    {
        return unlink($this->getPathByName($name));
    }
}

$app = new App();
$app->run();